'*** Programa AM5 - Estruc. Reticular Espacial Cargas nudos - QuickBASIC 4.0 *
'*** Autor:  Francisco Morn Cabr - Avenida de Amrica, 51 - 28.002  Madrid *


DEFINT I-N: OPTION BASE 1
OPEN "DATOS" FOR INPUT AS #1
OPEN "RES" FOR OUTPUT AS #2

Herc% = 0                  '*** Pantalla CGA. Para Hrcules, poner Herc% = 1
IF Herc% = 1 THEN npixx = 719: npixz = 347: ncarx = 9: ncarz = 14: rel = 1.5
IF Herc% = 0 THEN npixx = 639: npixz = 199: ncarx = 8: ncarz = 8: rel = 2.4

GOSUB Dat.Grales
GOSUB Abscisas
GOSUB Ordenadas
GOSUB Cotas
GOSUB Barras.Tipo
GOSUB Escalas
GOSUB Mat.Rigidez
GOSUB Numer.Nudos
GOSUB Carg.Nudos
'GOSUB Carg.Barras
GOSUB Apoyos
'GOSUB Print.Matriz
GOSUB Okey
GOSUB Sol.Sistema
GOSUB Graba.Resul

SCREEN 0: END


Dat.Grales:                           '*** Lectura del ttulo, datos grales
  INPUT #1, tit$                      '*** y dimensionamiento de las matrices
  er$ = "TITULO": GOSUB Fin.Grupo
  INPUT #1, Nnu, Nba, Ndi, Nhi, G, E  '*** N.Nudos, barr, difmax, hipt, G, E
  er$ = "DATOS GRALES": GOSUB Fin.Grupo
  Nec = 6 * Nnu: Nsb = 6 * (Ndi + 1)       '*** Nm. ecuac. y ancho semibanda
  DIM x(Nnu), y(Nnu), z(Nnu)               '*** Coordenadas de nudos
  DIM ni(Nba), nj(Nba), it(Nba)            '*** Incidencias y tipo de barras
  DIM R(Nec, Nsb), F(Nec, Nhi)             '*** Matrices de Rigidez y Cargas
  RETURN


Barras.Tipo:                    '*** Lectura Inerc. flex. y tors. barras tipo
  INPUT #1, Nbt: DIM Area(Nbt), Ifl1!(Nbt), Ifl2!(Nbt), Jtor!(Nbt)
  FOR i = 1 TO Nbt
    INPUT #1, Area(i), Ifl1!(i), Ifl2!(i), Jtor!(i)
  NEXT i: er$ = "BARRAS TIPO": GOSUB Fin.Grupo
  RETURN


Mat.Rigidez:                     '*** Lectura de datos barras, comprobacin,
  FOR iba = 1 TO Nba             '*** dibujo croquis y formac.matriz rigidez
    INPUT #1, i, j, ntip               '*** Incidencia y tipo de la barra
    IF ntip > Nbt OR i > Nnu OR j > Nnu OR i >= j OR j - i > Ndi THEN
       er$ = "BARRA " + STR$ (i) + " - " + STR$ (j): GOSUB Mensaje: END
    END IF
    ni(iba) = i: nj(iba) = j: it(iba) = ntip

    xi = (x(i) - xmin) * esx: zi = npixz - (z(i) - zmin) * esz
    xj = (x(j) - xmin) * esx: zj = npixz - (z(j) - zmin) * esz
    LINE (xi, zi)-(xj, zj)

    GOSUB Caract.Barra
    t = EAL * ca * ca + EI2L3 * se * se + EI1L3 * c2 * c2
    R(i1, 1) = R(i1, 1) + t: R(j1, 1) = R(j1, 1) + t   '*** Formacin  de la
    R(i1, 1 + jd) = -t                                 '*** matriz de rigidez
    t = EAL * ca * cb - EI2L3 * se * ce + EI1L3 * c2 * cs
    R(i1, 2) = R(i1, 2) + t: R(j1, 2) = R(j1, 2) + t
    R(i1, 2 + jd) = -t: R(i2, jd) = -t
    t = (EAL - EI1L3) * ca * cc
    R(i1, 3) = R(i1, 3) + t: R(j1, 3) = R(j1, 3) + t
    R(i1, 3 + jd) = -t: R(i3, -1 + jd) = -t
    t = EAL * cb * cb + EI2L3 * ce * ce + EI1L3 * cs * cs
    R(i2, 1) = R(i2, 1) + t: R(j2, 1) = R(j2, 1) + t
    R(i2, 1 + jd) = -t
    t = (EAL - EI1L3) * cb * cc
    R(i2, 2) = R(i2, 2) + t: R(j2, 2) = R(j2, 2) + t
    R(i2, 2 + jd) = -t: R(i3, jd) = -t
    t = EAL * cc * cc + EI1L3 * sc * sc
    R(i3, 1) = R(i3, 1) + t: R(j3, 1) = R(j3, 1) + t
    R(i3, 1 + jd) = -t
    t = GJL * ca * ca + 2 * (EI2L * c2 * c2 + EI1L * se * se)
    R(i4, 1) = R(i4, 1) + t: R(j4, 1) = R(j4, 1) + t
    R(i4, 1 + jd) = -GJL * ca * ca + EI2L * c2 * c2 + EI1L * se * se
    t = GJL * ca * cb + 2 * (EI2L * c2 * cs - EI1L * se * ce)
    R(i4, 2) = R(i4, 2) + t: R(j4, 2) = R(j4, 2) + t
    t = -GJL * ca * cb + (EI2L * cc * cc - EI1L) * se * ce
    R(i4, 2 + jd) = t: R(i5, jd) = t
    t = (GJL - 2 * EI2L) * ca * cc
    R(i4, 3) = R(i4, 3) + t: R(j4, 3) = R(j4, 3) + t
    t = -(GJL + EI2L) * ca * cc
    R(i4, 3 + jd) = t: R(i6, -1 + jd) = t
    t = GJL * cb * cb + 2 * (EI2L * cs * cs + EI1L * ce * ce)
    R(i5, 1) = R(i5, 1) + t: R(j5, 1) = R(j5, 1) + t
    R(i5, 1 + jd) = -GJL * cb * cb + EI2L * cs * cs + EI1L * ce * ce
    t = (GJL - 2 * EI2L) * cb * cc
    R(i5, 2) = R(i5, 2) + t: R(j5, 2) = R(j5, 2) + t
    t = -(GJL + EI2L) * cb * cc
    R(i5, 2 + jd) = t: R(i6, jd) = t
    t = GJL * cc * cc + 2 * EI2L * sc * sc
    R(i6, 1) = R(i6, 1) + t: R(j6, 1) = R(j6, 1) + t
    R(i6, 1 + jd) = -GJL * cc * cc + EI2L * sc * sc
    t = (EI2L2 - EI1L2) * cs * ce
    R(i1, 4) = R(i1, 4) + t: R(j1, 4) = R(j1, 4) - t
    R(i1, 4 + jd) = t: R(i4, -2 + jd) = -t
    t = (EI2L2 * se * se + EI1L2 * ce * ce) * cc
    R(i1, 5) = R(i1, 5) + t: R(j1, 5) = R(j1, 5) - t
    R(i1, 5 + jd) = t: R(i5, -3 + jd) = -t
    t = -EI2L2 * cb
    R(i1, 6) = R(i1, 6) + t: R(j1, 6) = R(j1, 6) - t
    R(i1, 6 + jd) = t: R(i6, -4 + jd) = -t
    t = -(EI2L2 * ce * ce + EI1L2 * se * se) * cc
    R(i2, 3) = R(i2, 3) + t: R(j2, 3) = R(j2, 3) - t
    R(i2, 3 + jd) = t: R(i4, -1 + jd) = -t
    t = (-EI2L2 + EI1L2) * cs * ce
    R(i2, 4) = R(i2, 4) + t: R(j2, 4) = R(j2, 4) - t
    R(i2, 4 + jd) = t: R(i5, -2 + jd) = -t
    t = EI2L2 * ca
    R(i2, 5) = R(i2, 5) + t: R(j2, 5) = R(j2, 5) - t
    R(i2, 5 + jd) = t: R(i6, -3 + jd) = -t
    t = EI1L2 * cb
    R(i3, 2) = R(i3, 2) + t: R(j3, 2) = R(j3, 2) - t
    R(i3, 2 + jd) = t: R(i4, jd) = -t
    t = -EI1L2 * ca
    R(i3, 3) = R(i3, 3) + t: R(j3, 3) = R(j3, 3) - t
    R(i3, 3 + jd) = t: R(i5, -1 + jd) = -t
  NEXT iba: er$ = "DEF. DE BARRAS": GOSUB Fin.Grupo
  RETURN


Carg.Nudos:                            '*** Lectura cargas nudos y formacin
  FOR ih = 1 TO Nhi                    '*** de trminos independientes
      INPUT #1, Nnc                       '*** Nm. de nudos con cargas
      FOR inu = 1 TO Nnc
          INPUT #1, nn, Fx, Fy, Fz, Mx!, My!, Mz!   ' Nudo cargado, momtos.
          i = 6 * (nn - 1) + 1                      ' y fuerzas
          F(i, ih) = Fx: F(i + 1, ih) = Fy: F(i + 2, ih) = Fz
          F(i + 3, ih) = Mx!: F(i + 4, ih) = My!: F(i + 5, ih) = Mz!
      NEXT inu
  NEXT ih: er$ = "CARGAS EN NUDOS": GOSUB Fin.Grupo
  RETURN


Apoyos:                               '*** Lectura def. apoyos y modificacin
  INPUT #1, Nap                       '*** de la matriz de rigidez
  FOR iap = 1 TO Nap                                   '*** Nm. de apoyos
     INPUT #1, na                                      '*** Nudo apoyo
     ifi = 6 * (na - 1) + 1:                           '*** Fila a modificar
     FOR i = ifi TO ifi + 5
         INPUT #1, coac                                '*** Coacc/coef muelle
         IF coac <> 1 THEN
            IF coac = 0 THEN R(i, 1) = 1E+20 ELSE R(i, 1) = R(i, 1) + coac
         END IF
     NEXT i
  NEXT iap: er$ = "DEFINICION APOYOS": GOSUB Fin.Grupo: CLOSE #1
  RETURN


Graba.Resul:                           '*** Clculo y grabacin de resultados
  PRINT : PRINT "GRABANDO RESULTADOS"
  b$ = " Nudo   Despl. x    Despl. y    Despl. z "
  b$ = b$ + "    Giro x      Giro y      Giro z "
  c$ = "#### #####.##### #####.##### #####.##### "
  h$ = "#####.##### "
  FOR ih = 1 TO Nhi
    PRINT #2, : PRINT #2, : PRINT #2, TAB(10); tit$
    PRINT #2, : PRINT #2, TAB(30); "HIPOTESIS NUM."; ih
    PRINT #2, : PRINT #2, TAB(26); "DESPLAZAMIENTOS DE NUDOS"
    PRINT #2, : PRINT #2, b$
    PRINT #2, : i = 1
    FOR inu = 1 TO Nnu
      PRINT #2, USING c$; inu, F(i, ih), F(i + 1, ih), F(i + 2, ih);
      PRINT #2, USING h$; F(i + 3, ih), F(i + 4, ih), F(i + 5, ih)
      i = i + 6
    NEXT inu
    PRINT #2, : PRINT #2,
    PRINT #2, TAB(30); "ESFUERZOS EN BARRAS": PRINT #2,
    PRINT #2, "  i   j    E.Axil  Cte. 2  Cte. 1   M.Tors.";
    PRINT #2, " Flec.1i  Flec.1j  Flec.2i  Flec.2j": PRINT #2,
    FOR iba = 1 TO Nba
      i = ni(iba): j = nj(iba): ntip = it(iba)
      GOSUB Caract.Barra
      xi = F(i1, ih): xj = F(j1, ih)
      yi = F(i2, ih): yj = F(j2, ih)
      zi = F(i3, ih): zj = F(j3, ih)
      ui = F(i4, ih): uj = F(j4, ih)
      vi = F(i5, ih): vj = F(j5, ih)
      wi = F(i6, ih): wj = F(j6, ih)
      dx = xj - xi: dy = yj - yi: dz = zj - zi
      du = uj - ui: dv = vj - vi: dw = wj - wi
      su = uj + ui: sv = vj + vi: sw = wj + wi
      ax = (dx * ca + dy * cb + dz * cc) * EAL                    '* Axil
      c = dy * ce - dx * se
      cd = c * EI2L3 + (c2 * su + cs * sv - sc * sw) * EI2L2      '* Cte.2
      s = dz * sc - dy * cs - dx * c2
      cu = s * EI1L3 - (se * su - ce * sv) * EI1L2                '* Cte.1
      tr = (du * ca + dv * cb + dw * cc) * GJL                    '* Torsor
      f1i = ((su + ui) * se - (sv + vi) * ce) * EI1L - s * EI1L2  '* Flec.1i
      f1j = ((su + uj) * se - (sv + vj) * ce) * EI1L - s * EI1L2  '* Flec.1j
      f2i = (su + ui) * c2 + (sv + vi) * cs - (sw + wi) * sc
      f2i = f2i * EI2L + c * EI2L2                                '* Flec.2i
      f2j = (su + uj) * c2 + (sv + vj) * cs - (sw + wj) * sc
      f2j = f2j * EI2L + c * EI2L2                                '* Flec.2j
      PRINT #2, USING "### ###"; i, j;
      PRINT #2, USING "######.###"; ax;
      PRINT #2, USING "####.###"; cd, cu;
      PRINT #2, USING "#####.###"; tr, f1i, f1j, f2i, f2j
    NEXT iba
  NEXT ih
  RETURN


Caract.Barra:           '*** Clc. caract. barra para matriz rigid. y esfuer.
    i1 = 6 * (i - 1) + 1: i2 = i1 + 1: i3 = i1 + 2      '*Filas modif.nudo i
    i4 = i1 + 3: i5 = i1 + 4: i6 = i1 + 5
    j1 = 6 * (j - 1) + 1: j2 = j1 + 1: j3 = j2 + 1      '*Filas modif.nudo j
    j4 = j1 + 3: j5 = j1 + 4: j6 = j1 + 5
    jd = 6 * (j - i)                                    '*Distancia i - j
    dx = x(j) - x(i): dy = y(j) - y(i): dz = z(j) - z(i)
    rp = SQR(dx * dx + dy * dy)                     '*** Long. proyecc. barra
    rl = SQR(rp * rp + dz * dz)                     '*** Long. barra
    IF ABS(rp) > .0001 THEN ce = dx / rp: se = dy / rp ELSE ce = 1: se = 0
    ca = dx / rl: cb = dy / rl: cc = dz / rl        '*** Cosenos directores
    sc = rp / rl: cs = cc * se: c2 = cc * ce
    EAL = E * Area(ntip) / rl
    GJL = G * Jtor!(ntip) / rl                      '*** Eltos. para clculo
    EI1L = 2 * E * Ifl1!(ntip) / rl                 '*** de coefs. de matriz
    EI1L2 = 6 * E * Ifl1!(ntip) / rl / rl           '*** de rigidez
    EI1L3 = 12 * E * Ifl1!(ntip) / rl / rl / rl
    EI2L = 2 * E * Ifl2!(ntip) / rl
    EI2L2 = 6 * E * Ifl2!(ntip) / rl / rl
    EI2L3 = 12 * E * Ifl2!(ntip) / rl / rl / rl
    RETURN








